/*
  Copyright (C) 2013 Harry

 This file is part of spacewar.

 spacewar is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 spacewar is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with spacewar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "weaver/weaver.h"
#include "game.h"

int main(int argc, char **argv){
  awake_the_weaver(); // Initializing Weaver API
  initialize_star();
  initialize_ships(2);
  initialize_cameras();
  initialize_dust();
  initialize_shot();
  hide_cursor();

  // Main loop
  play_music("music.ogg");
  for(;;){
    get_input();

    erase_ships();
    erase_dust();
    erase_shot();

    if(keyboard[ESC]){
      break;
    }
    // Player 1 moves
    if(keyboard[LEFT])
      rotate_ship(0, LEFT);
    if(keyboard[RIGHT])
      rotate_ship(0, RIGHT);
    if(keyboard[UP])
      propulse_ship(0);
    if(keyboard[DOWN])
      ship_fire(0);
    if(keyboard[RIGHT_CTRL])
      goto_hyperspace(0);

    // Player 2 moves
    if(keyboard[A])
      rotate_ship(1, LEFT);
    if(keyboard[D])
      rotate_ship(1, RIGHT);
    if(keyboard[W])
      propulse_ship(1);
    if(keyboard[L])
      blow_up(1);
    if(keyboard[S])
      ship_fire(1);
    if(keyboard[LEFT_CTRL])
      goto_hyperspace(1);

    update_dust();
    update_star();
    update_ships();
    update_shot();
    film_ships();
    film_dust();
    film_shot();
    draw_tank(0, window_width / 2 - 421, window_height / 2 - 150);
    draw_tank(1, window_width / 2 + 401, window_height / 2 - 150);
    weaver_rest(10000000);
  }
  stop_music();

  destroy_dust();
  destroy_star();
  destroy_ships();
  destroy_shot();
  may_the_weaver_sleep();
  return 0;
}
